/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TUSE                                                     */
/* Tabela : TURNOSERV                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 02/08/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TUSE
BEFORE INSERT OR UPDATE OR DELETE
ON TURNOSERV FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTUSE := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFILIAL,0)     <> NVL(:NEW.CDFILIAL,0))     OR
         (NVL(:OLD.CDSERVFILI,0)   <> NVL(:NEW.CDSERVFILI,0))   OR
         (NVL(:OLD.QTCOMESTTSEG,0) <> NVL(:NEW.QTCOMESTTSEG,0)) OR
         (NVL(:OLD.QTCOMESTTTER,0) <> NVL(:NEW.QTCOMESTTTER,0)) OR
         (NVL(:OLD.QTCOMESTTQUA,0) <> NVL(:NEW.QTCOMESTTQUA,0)) OR
         (NVL(:OLD.QTCOMESTTQUI,0) <> NVL(:NEW.QTCOMESTTQUI,0)) OR
         (NVL(:OLD.QTCOMESTTSEX,0) <> NVL(:NEW.QTCOMESTTSEX,0)) OR
         (NVL(:OLD.QTCOMESTTSAB,0) <> NVL(:NEW.QTCOMESTTSAB,0)) OR
         (NVL(:OLD.QTCOMESTTDOM,0) <> NVL(:NEW.QTCOMESTTDOM,0)) OR
         (NVL(:OLD.QTCOMESTTFER,0) <> NVL(:NEW.QTCOMESTTFER,0)) OR
         (NVL(:OLD.CDTURNO,0)      <> NVL(:NEW.CDTURNO,0))      OR
         (NVL(:OLD.NMTURNO,0)      <> NVL(:NEW.NMTURNO,0)) THEN
         :NEW.DTULTATUTUSE := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TURNOSERV', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';CDSERVFILI='||:OLD.CDSERVFILI||';CDTURNO='||:OLD.CDTURNO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TURNOSERV MODIFY DTULTATUTUSE DEFAULT SYSDATE
/
